{
  AniMapa, knihovna pomocnch procedur
  L.P.2012 lopotn stvoil kiReGPS (za pomoci Gorda a nejprve opisovn od Mikroma a pak i jeho spoluautorstv, dky...)

}

{-----------------------------------------------------------------------------------------------------------------------
  najde v poli mapu podle nzvu a nastav globln promnn}
procedure SetMapByName(mapName: string);
var
  i: integer;
begin
  for i := 1 to mapCount do
  begin
    if mapName = mapList[i].Name then
    begin
      selectedMap := i; 
      AniMapaForm_ComboBoxMap.Text := mapList[i].Name
      exit; 
    end;
  end;
  selectedMap := 1; 
  AniMapaForm_ComboBoxMap.Text := mapList[1].Name
end;

{-----------------------------------------------------------------------------------------------------------------------
  nate seznam dostupnch map podle INI soubor v adresi mapFolder}
procedure ReadMapList;
var
  listINI: TStringList;
  i,ii: Integer;
begin
  listINI := TStringList.Create();
  FileList(GEOGET_SCRIPTDIR + mapFolder, listINI)
  ii := 0
  for i := 0 to listINI.Count-1 do begin
    {bere jen INI soubory s definic mapy}
    if(Uppercase(Copy(listINI[i],Length(listINI[i])-3,4))='.INI') then begin
      ii := ii + 1;
      mapCount := ii;
      ini := TIniFile.Create(listINI[i]);
      try
        mapList[ii].Name := ini.ReadString('Map','Name','');
        AniMapaForm_ComboBoxMap.items.Add(mapList[ii].Name);
        mapList[ii].File := ini.ReadString('Map','File','');
        mapList[ii].INIfile := listINI[i];
      finally
        ini.Free;
      end;
    end;
  end;
  listINI.Free();
  if mapCount = 0 then
  begin
    ShowMessage(_('There is no map file in the folder ') + mapFolder + _('!'));
    GeoAbort;
  end
  else SetMapByName(AniMapaForm_ComboBoxMap.Text);
end;

{-----------------------------------------------------------------------------------------------------------------------
  nate parametry z INI pluginu, pedevm posledn volby formule}
procedure ReadSettings;
begin
  ini := TIniFile.Create(GEOGET_SCRIPTDIR + '\AniMapa\AniMapa.ini');
  try
    staySilent := ini.ReadBool('AniMapa','Silent',false);
    AniMapaForm_ComboBoxMap.Text := ini.ReadString('AniMapa','Map','');
    AniMapaForm_RadioGroupIcons.ItemIndex := StrToInt(ini.ReadString('AniMapa','IconSize','0'));
    AniMapaForm_ComboBoxDelay.Text := ini.ReadString('AniMapa','Delay','50');
    AniMapaForm_CheckBoxLoop.Checked := ini.ReadBool('AniMapa','Loop',false);
    AniMapaForm_CheckBoxDateCounter.Checked := ini.ReadBool('AniMapa','Counter',true);
    AniMapaForm_CheckBoxCacheCounter.Checked := ini.ReadBool('AniMapa','CacheCounter',false);
    AniMapaForm_CheckBoxFTF.Checked := ini.ReadBool('AniMapa','FTF',true);
    AniMapaForm_CheckBoxMilestone.Checked := ini.ReadBool('AniMapa','Milestones',false);
  finally
    ini.Free;
  end;
end;

{-----------------------------------------------------------------------------------------------------------------------
  ulo parametry do INI pluginu, pedevm posledn volby formule}
procedure SaveSettings;
begin
  ini := TIniFile.Create(GEOGET_SCRIPTDIR+'\AniMapa\AniMapa.ini');
  try
    with ini do
    begin
      WriteBool('AniMapa','Silent',staySilent);
      WriteString('AniMapa','Map',AniMapaForm_ComboBoxMap.Text);
      WriteString('AniMapa','IconSize',IntToStr(AniMapaForm_RadioGroupIcons.ItemIndex));
      WriteString('AniMapa','Delay',AniMapaForm_ComboBoxDelay.Text);
      WriteBool('AniMapa','Loop',AniMapaForm_CheckBoxLoop.Checked);
      WriteBool('AniMapa','Counter',AniMapaForm_CheckBoxDateCounter.Checked);
      WriteBool('AniMapa','CacheCounter',AniMapaForm_CheckBoxCacheCounter.Checked);
      WriteBool('AniMapa','FTF',AniMapaForm_CheckBoxFTF.Checked);
      WriteBool('AniMapa','Milestones',AniMapaForm_CheckBoxMilestone.Checked);
    end;
  finally
    ini.Free;
  end;
end;

{-----------------------------------------------------------------------------------------------------------------------
  nastav globln parametry animace}
procedure SetGlobalParams;
var
  coordLatTLstring: string;
  coordLonTLstring: string;
  coordLatBRstring: string;
  coordLonBRstring: string;
  coordLatTL: single;
  coordLonTL: single;
  coordLatTR: single;
  coordLonTR: single;
  coordLatBL: single;
  coordLonBL: single;
  coordLatBR: single;
  coordLonBR: single;
  i: integer;
begin
  {nastav prodlevu animace vech frame v destkch ms}
  cacheDelay := StrToInt(AniMapaForm_ComboBoxDelay.Text) div 10;
  {nastav jmno tagu pro xTF nlezy}
  if tagxTF = '' then tagFTF := tagFTFDefault else tagFTF := tagxTF;
  {nastav zvolenou mapu}
  SetMapByName(AniMapaForm_ComboBoxMap.Text);
  {nate kalibraci zvolen mapy}
  ini := TIniFile.Create(mapList[selectedMap].INIfile);
  try
    GIFsizeX := StrToInt(ini.ReadString('Map','PixelWidth','0'));
    GIFsizeY := StrToInt(ini.ReadString('Map','PixelHeight','0'));
    posDateX := StrToInt(ini.ReadString('Map','PosDateX','0'));
    posDateY := StrToInt(ini.ReadString('Map','PosDateY','0'));
    coordLatTLstring := ini.ReadString('Calibration','coordLatTL','0');
    coordLonTLstring := ini.ReadString('Calibration','coordLonTL','0');
    coordLatBRstring := ini.ReadString('Calibration','coordLatBR','0');
    coordLonBRstring := ini.ReadString('Calibration','coordLonBR','0');
    coordLatTR := StrToFloat(ini.ReadString('Calibration','coordLatTR',coordLatTLstring));
    coordLonTR := StrToFloat(ini.ReadString('Calibration','coordLonTR',coordLonBRstring));
    coordLatBL := StrToFloat(ini.ReadString('Calibration','coordLatBL',coordLatBRstring));
    coordLonBL := StrToFloat(ini.ReadString('Calibration','coordLonBL',coordLonBRstring));
  finally
    ini.Free;
  end;
  coordLatTL := StrToFloat(coordLatTLstring);
  coordLonTL := StrToFloat(coordLonTLstring);
  coordLatBR := StrToFloat(coordLatBRstring);
  coordLonBR := StrToFloat(coordLonBRstring);
  {piprav hodnoty pro pepoet souadnic kee na pozici v map, zatm jen jednodue podle TL, BR}
  coordLatBase := coordLatTL; 
  coordLonBase := coordLonTL;
  coordXratio := GIFsizeX/(coordLonBR - coordLonTL);
  coordYratio := GIFsizeY/(coordLatBR - coordLatTL); 

  {nate ikony zvolen velikosti}
  case AniMapaForm_RadioGroupIcons.ItemIndex of
  0: 
    begin 
      iconSetGreen := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'green 5.bin')
      iconSetYellow := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'yellow 5.bin')
      iconSetBlue := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'blue 5.bin')
      iconSetGray := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'gray 5.bin')
      iconSetRed := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'red 5.bin')
      iconSize := 5;
    end;
  1:
    begin 
      iconSetGreen := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'green 5 PT.bin')
      iconSetYellow := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'yellow 5 PT.bin')
      iconSetBlue := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'blue 5 PT.bin')
      iconSetGray := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'gray 5 PT.bin')
      iconSetRed := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'red 5 PT.bin')
      iconSize := 5;
    end;
  2: 
    begin 
      iconSetGreen := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'green 9.bin')
      iconSetYellow := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'yellow 9.bin')
      iconSetBlue := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'blue 9.bin')
      iconSetGray := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'gray 9.bin')
      iconSetRed := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'red 9.bin')
      iconSize := 9;
    end;
  3: 
    begin 
      iconSetGreen := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'green 12.bin')
      iconSetYellow := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'yellow 12.bin')
      iconSetBlue := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'blue 12.bin')
      iconSetGray := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'gray 12.bin')
      iconSetRed := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'red 12.bin')
      iconSize := 12;
    end;
  end;

  {nate cifry pro zobrazovn data}
  for i := 0 to 9 do cipherSizeA[i] := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'w' + IntToStr(i) + '.bin');
  cipherSizeA[10] := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'whash.bin')
  cipherSizeA[11] := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'wminus.bin')

  {nate cifry pro zobrazovn sla nlezu}
  for i := 0 to 9 do cipherSizeB[i] := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'wa' + IntToStr(i) + '.bin');
  cipherSizeB[10] := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'wahash.bin')
  cipherSizeB[11] := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'waminus.bin')

  {nate medaile xTF}
  medalFTF := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'FTF.bin')
  medalSTF := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'STF.bin')
  medalTTF := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'TTF.bin')
  medalOther := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'xTF.bin')

  {nate przdn frame pro vytvoen prodlevy na konci animace}
  emptyFrame := FileToString(GEOGET_SCRIPTDIR + iconFolder + 'empty.bin')
end;

{-----------------------------------------------------------------------------------------------------------------------
  piprav zklad pro generovanou mapu do vstupnho adrese
  odebrnm koncovho znaku ";" z GIFu zkladn mapy a doplnnm rmce Netscape}
procedure PrepareMap;
begin
  if not FileExists(GEOGET_SCRIPTDIR + mapFolder + mapList[selectedMap].File) then
    begin
	    ShowMessage('Mapov soubor "' + mapList[selectedMap].File + '" neexistuje!');
      GeoAbort;
    end;
    
  mapString := FileToString(GEOGET_SCRIPTDIR + mapFolder + mapList[selectedMap].File);
  mapString := Copy(mapString, 1, Length(mapString)-1);
  {Netscape rmec animovanho GIFu}
  mapString := mapString + Chr($21) + Chr($FF) + Chr($0B) + Chr($4E) + Chr($45) + Chr($54) + Chr($53) + Chr($43) + Chr($41);
  mapString := mapString + Chr($50) + Chr($45) + Chr($32) + Chr($2E) + Chr($30) + Chr($03) + Chr($01);
  {Netscape rmec - poet opakovn}
  mapString := mapString + Chr($00) + Chr($00) {nekonen}
  {Netscape rmec - zakonen}
  mapString := mapString + Chr($00);
end;

{-----------------------------------------------------------------------------------------------------------------------
  pid frame s ikonou kee na pozici mapy dle souadnic a typu}
procedure CreateCacheFrame(geo: TGeo; num: integer);
var
  frame: string;
  posX, posY: integer;
begin
  case geo.CacheType of
    'Traditional Cache': frame := iconSetGreen;
    'Project APE Cache': frame := iconSetGreen;
    'Letterbox Hybrid': frame := iconSetGreen;
    'Multi-cache': frame := iconSetYellow;
    'Unknown Cache': frame := iconSetBlue;
    'Wherigo Cache': frame := iconSetGray;
    'Webcam Cache': frame := iconSetGray;
    'Earthcache': frame := iconSetGray;
    'Virtual Cache': frame := iconSetGray;
  else
    {ostatn typy: 'Event Cache'  'Mega-Event Cache'  'Cache In Trash Out Event'  'Lost and Found Event Cache'}
    frame := iconSetRed;  
  end;
  {souadnice rmce - X, Y, vdy ni, vy byte}
  posX := Round((geo.LonNum - coordLonBase)*coordXratio) - (iconSize div 2);
  posY := Round((geo.LatNum - coordLatBase)*coordYratio) - (iconSize div 2);

  {pokud spad ke do rozsahu mapy...}
  if (posX >= 0) and (posY >= 0) and (posX < (GIFsizeX - iconSize)) and (posY < (GIFsizeY - iconSize)) then 
  begin
    if AniMapaForm_RadioGroupIcons.ItemIndex <> 4 then
    begin
      {pokud spad keka do mapy, vykreslme j separtnm rmcem}
      {hlavika rmce - zatek}
      mapString := mapString + Chr($21) + Chr($F9) + Chr($04) + Chr($01);
      {hlavika rmce - prodleva v 10 ms - v relu ale pro mal hodnoty neodpovd}
      mapString := mapString + Chr(cacheDelay mod 256) + Chr(cacheDelay div 256);
      {hlavika rmce - konec}
      mapString := mapString + Chr($00) + Chr($00);
      {zatek rmce}
      mapString := mapString + Chr($2C);
      {souadnice rmce - X, Y, vdy ni, vy byte}
      mapString := mapString + Chr(posX mod 256) + Chr(posX div 256);
      mapString := mapString + Chr(posY mod 256) + Chr(posY div 256);
      {ikonka s lokln paletou}
      mapString := mapString + frame;
    end;
    
    {pokud m keka xTF tag a je zvoleno zobrazen medail, plcne ji ke kece}
    if AniMapaForm_CheckBoxFTF.Checked then
    begin
      if geo.TagHavecategory(tagFTF) then
      begin
        case Uppercase(geo.TagValues(tagFTF)) of
          'FTF': frame := medalFTF;
          'STF': frame := medalSTF;
          'TTF': frame := medalTTF;
        else
          frame := medalOther;
        end;
        {hlavika rmce - zatek}
        mapString := mapString + Chr($21) + Chr($F9) + Chr($04) + Chr($01);
        {hlavika rmce - prodleva v 10 ms - v relu ale pro mal hodnoty neodpovd}
        mapString := mapString + Chr(cacheDelay mod 256) + Chr(cacheDelay div 256);
        {hlavika rmce - konec}
        mapString := mapString + Chr($00) + Chr($00);
        {zatek rmce}
        mapString := mapString + Chr($2C);
        {souadnice rmce - X, Y, vdy ni, vy byte}
        mapString := mapString + Chr((posX + (iconSize div 2) - 3) mod 256) + Chr((posX + (iconSize div 2) - 3) div 256);
        mapString := mapString + Chr((posY + (iconSize div 2)) mod 256) + Chr((posY + (iconSize div 2)) div 256);
        {ikonka s lokln paletou}
        mapString := mapString + frame;
      end;
    end;

    {pokud je keka stovkovm milnkem (stovky u nich, pak tiscovky) a je zvoleno jejich zobrazen, pid cedulku}
    if AniMapaForm_CheckBoxMilestone.Checked and (num mod 100 = 0) then
      if FileExists(GEOGET_SCRIPTDIR + iconFolder + IntToStr(num) + '.bin') then
      begin
        frame := FileToString(GEOGET_SCRIPTDIR + iconFolder + IntToStr(num) + '.bin');
        {hlavika rmce - zde nen nastavena prhlednost}
        mapString := mapString + Chr($21) + Chr($F9) + Chr($04) + Chr($00);
        {hlavika rmce - prodleva v 10 ms - v relu ale pro mal hodnoty neodpovd}
        mapString := mapString + Chr(minDelay mod 256) + Chr(minDelay div 256);
        {hlavika rmce - konec}
        mapString := mapString + Chr($00) + Chr($00);
        {zatek rmce}
        mapString := mapString + Chr($2C);
        {souadnice rmce - X, Y, vdy ni, vy byte}
        mapString := mapString + Chr((posX + (iconSize div 2)) mod 256) + Chr((posX + (iconSize div 2)) div 256);
        mapString := mapString + Chr((posY + (iconSize div 2) - labelSize) mod 256) + Chr((posY + (iconSize div 2) - labelSize) div 256);
        {ikonka s lokln paletou}
        mapString := mapString + frame;
      end;
  end;
end;

{-----------------------------------------------------------------------------------------------------------------------
  pid frame s jednou cifrou}
procedure CreateCipherFrame(cipher: string; cipherNum: array of string; posCiphX: integer; posCiphY: integer);
var
  frame: string;
begin
  case cipher of
    '0': frame := cipherNum[0]; 
    '1': frame := cipherNum[1]; 
    '2': frame := cipherNum[2]; 
    '3': frame := cipherNum[3]; 
    '4': frame := cipherNum[4]; 
    '5': frame := cipherNum[5]; 
    '6': frame := cipherNum[6]; 
    '7': frame := cipherNum[7]; 
    '8': frame := cipherNum[8];
    '9': frame := cipherNum[9];
    '#': frame := cipherNum[10];
  else
    frame := cipherNum[11];             // jinak znak '-'   
  end; 
  begin
    {hlavika rmce - zde nen nastavena prhlednost}
    mapString := mapString + Chr($21) + Chr($F9) + Chr($04) + Chr($00);
    {hlavika rmce - prodleva v 10 ms - v relu ale pro mal hodnoty neodpovd}
    mapString := mapString + Chr(minDelay mod 256) + Chr(minDelay div 256);
    {hlavika rmce - konec}
    mapString := mapString + Chr($00) + Chr($00);
    {zatek rmce}
    mapString := mapString + Chr($2C);
    {souadnice rmce - X, Y, vdy ni, vy byte}
    mapString := mapString + Chr(posCiphX mod 256) + Chr(posCiphX div 256);
    mapString := mapString + Chr(posCiphY mod 256) + Chr(posCiphY div 256);
    {cifra s lokln paletou}
    mapString := mapString + frame;
  end;
end;

{-----------------------------------------------------------------------------------------------------------------------
  pid frame s prodlevou na konci animace}
procedure CreateWaitFrame(waitDelay: integer);
begin
  {hlavika rmce}
  mapString := mapString + Chr($21) + Chr($F9) + Chr($04) + Chr($01);
  {prodleva v nsobcch 10 ms}
  mapString := mapString + Chr(waitDelay mod 256) + Chr(waitDelay div 256);
  {zakonen hlaviky a zatek rmce}
  mapString := mapString + Chr($00) + Chr($00) + Chr($2C) + Chr($00) + Chr($00) + Chr($00) + Chr($00);
  {przdn frame}
  mapString := mapString + emptyFrame;
end;

{-----------------------------------------------------------------------------------------------------------------------
  pid frame s datumem - zobrazuje jen zmnn cifry}
procedure CreateDateFrame(M: word; Y: word);
var
  actDateString: string;
  posX, posY, i: integer;
begin
  posX := posDateX;
  posY := posDateY;
  {to je tak, kdy nkdo neum naformtovat slo na dv cifry}
  if M > 9 then actDateString := IntToStr(M) + '-' + IntToStr(Y)
  else actDateString := '0' +IntToStr(M) + '-' + IntToStr(Y);
  if prevDateString = '' then prevDateString := '       '; 
  for i := 1 to Length(actDateString) do
  begin
    if Copy(actDateString,i,1) <> Copy(prevDateString,i,1) then CreateCipherFrame(Copy(actDateString,i,1), cipherSizeA, posX, posY);
    posX := posX + ciphSizeAWidth;
  end;
  prevDateString := actDateString;
end;

{-----------------------------------------------------------------------------------------------------------------------
  pid frame s slem nlezu po stovkch - zobrazuje jen zmnn cifry}
procedure CreateCacheNumFrame(ii: integer);
var
  actNumString: string;
  posX, posY, i: integer;
begin
  posX := posDateX + 7 * ciphSizeAWidth - 7 * ciphSizeBWidth;
  posY := posDateY + ciphNumDist;
  {zase trochu neobratn zarovnn sla nlezu doprava}
  actNumString := Copy('       ',1,7-Length(IntToStr(ii))-1) + '#' + IntToStr(ii); 
  if prevNumString = '' then prevNumString := '       '; 
  for i := 1 to Length(actNumString) do
  begin
    if Copy(actNumString,i,1) <> Copy(prevNumString,i,1) then CreateCipherFrame(Copy(actNumString,i,1), cipherSizeB, posX, posY);
    posX := posX + ciphSizeBWidth;
  end;
  prevNumString := actNumString;
end;

{-----------------------------------------------------------------------------------------------------------------------
  ukon vygenerovanou mapu a ulo do vstupnho adrese}
procedure CloseMap;
begin
  {koncov znak}
  mapString := mapString + ';'
  {uloen do vstupnho adrese - definice podle config.pas, pokud adrese, pokud nen}
  if outMapFolder = '' then outFolder := GEOGET_SCRIPTDIR + outFolderDefault else outFolder := outMapFolder; 
  if not DirectoryExists(outFolder) then ForceDirectories(outFolder);
  StringToFile(mapString, outFolder + mapList[selectedMap].File);
end;
