{
  AniMapa, hlavn procedury
  L.P.2012 lopotn stvoil kiReGPS (za pomoci Gorda a nejprve opisovn od Mikroma a pak i jeho spoluautorstv, dky...)

  verze:
   5.12.2012  prvn rann betaverze 0.0.1
   8.12.      beta 0.0.2, seznam zmn:
                - azen datum a as
                - pidny medaile za xTF   
   8.12.      verze 1.0.0, seznam zmn:
                - monost zvolit jen xTF medaile bez ikonek
                - lokalizovno (anglitina, etina)
                - po generovn nabdnuta mapa k zobrazen v browseru (dky, Mikrome)
  14.12.      verze 1.0.1, seznam zmn:
                - parametrizace vstupnho adrese do config.pas
                - silent verze skriptu (AniMapaSilent.ggp.pas)
                - pluginy zaazeny do skupiny AniMapa (u starch instalac se nepemst)
                - potadlo nlez (po stovkch) pod msc a rok
  14.12.      verze 1.0.2, seznam zmn:
                - volba rychlosti animace prodlevou fram 20-200 ms (piem 20 ms je 5x vy rychlost, ne pvodn)
                - doplnn rmce s prodlevou na konci animace
                - doplnn Netscape rmce i u GIF bez opakovn (z dvodu snahy o maximln kompatibilitu)
                - parametrizace voln browseru s vygenerovanou mapou (nen spolen cesty) - Chrome|IE|Firefox|Opera
  16.12.      verze 1.0.3, seznam zmn:
                - parametrizace tagu s xTF nlezy do config.pas
                - powertrailov verze ikonek ke
                - pidny cedulky stovkovch milnk
}

uses
  AniMapaForm;

const
  outFolderDefault = '\AniMapa\output\';  // vchoz adres pro uloen vslednch animac, plat pokud nen zadn parametr OutMapFolder v config.pas
  mapFolder = '\AniMapa\maps\';           // adres s mapovmi pedlohami 
  iconFolder = '\AniMapa\icons\';         // adres s ikonkami ke, cifer apod. (obsahuje soubory .BIN s hlavn st frame ikony)
  maxMaps = 100;                          // maximln poet mapovch pedloh
  ciphSizeAWidth = 31;                    // ka ikon cifer velikosti A (pro datum)
  ciphSizeBWidth = 21;                    // ka ikon cifer velikosti B (pro slo nlezu)
  ciphNumDist = 60;                       // vertikln posun sla nlezu
  tagFTFDefault = 'FTF';                  // vchoz tag s indikac xTF nlezu, plat pokud nen zadn parametr TagxTF v config.pas 
  minDelay = 2;                           // minimln prodleva animovanch frame (nsobky 10 ms)
  postDelay = 500;                        // prodleva na konci opakovan animace (nsobky 10 ms)
  maxDelay = 65000;                       // prodleva na konci animace bez opakovn(nsobky 10 ms)
  labelSize = 10;                         // velikost (vka) milnkov cedulky

type recMap = Record
  Name: string;
  File: string;
  INIfile: string;
end;

var
  ini: TIniFile;
  staySilent: boolean;
  mapList: array[1..maxMaps] of recMap;
  mapCount: integer;
  selectedMap: integer;
  cacheDelay: integer;
  outFolder: string;
  tagFTF: string;
  coordLatBase: single;
  coordLonBase: single; 
  coordXratio: single;
  coordYratio: single;
  GIFsizeX: integer;
  GIFsizeY: integer;
  posDateX: integer;
  posDateY: integer;
  mapString: string;
  iconSetGreen: string;
  iconSetYellow: string;
  iconSetBlue: string;
  iconSetGray: string;
  iconSetRed: string;
  iconSize: integer;
  medalFTF: string;
  medalSTF: string;
  medalTTF: string;
  medalOther: string;
  cipherSizeA: array[0..11] of string;
  cipherSizeB: array[0..11] of string;
  prevDateString: string;
  prevNumString: string;
  emptyFrame: string;

{$include AniMapa.config.pas}
{$include AniMapaLib.pas}

{-----------------------------------------------------------------------------------------------------------------------
  generovn animovanho GIFu vybran mapy}
procedure GenerateMap;
var
  tab: TSqliteTable;
  geo: TGeo;
  actY, actM, actD: word;
  max, counter: integer;
begin
  {pprava zkladn mapy}
  PrepareMap;
  geo := TGeo.create;
  try
    {cyklus pes vechny nalezen keky}
    counter := 0;
    GeoBusyStart;
    GeoBusyCaption(_('Animated map of founds'));
    max := Geoget_DB.GetTableValue('SELECT count(*) FROM geocache WHERE dtfound > 0');
    tab := Geoget_DB.GetTable('SELECT * FROM geocache WHERE dtfound > 0 ORDER BY dtfound, dtfoundtime', false);
    try
      while not tab.eof do
      begin
        if GeoBusyTest then Break;
        counter := counter + 1;
        GeoBusyProgress(Counter, max);
        geo.LoadCurrent(tab);
        {k map pid rmec s kekou na pozici souadnic}
        CreateCacheFrame(geo, counter);
        DecodeDate(geo.Found,actY,actM,actD)
        {k map pid rmec s mscem a rokem a potadlem nlez}
        if AniMapaForm_CheckBoxDateCounter.Checked then CreateDateFrame(actM, actY);
        {k map pid rmec s potadlem nlez po stovkch}
        if AniMapaForm_CheckBoxCacheCounter.Checked and ((counter mod 100) = 0) then CreateCacheNumFrame(counter);
        GeoBusyKind(_('Generating animation: year ') + IntToStr(actY) + _(', month ') + IntToStr(actM));
        tab.next;
      end;
      {a na zvr jet i posledn slo nlezu}
      if AniMapaForm_CheckBoxCacheCounter.Checked then CreateCacheNumFrame(counter);
      {poslednm frame je prodleva - maximln nebo krtk prodleva mezi opakovnm}
      if AniMapaForm_CheckBoxLoop.Checked then 
        CreateWaitFrame(postDelay)
      else
        CreateWaitFrame(maxDelay);
    finally
      tab.free;
    end;
  finally
    geo.free;
  end;
  if not GeoBusyTest then
  begin
    CloseMap;
    if not staySilent then
      if MessBox(_('Animated map "') + mapList[selectedMap].Name + _('" created to file ') + outFolder + mapList[selectedMap].File + CRLF + CRLF + _('Would you like to open it in your browser?'), _('Finished!'), 4) = 6 then
      case browserType of
        'Chrome': BrowseURL('file:///"' + outFolder + mapList[selectedMap].File + '"');
      else
        {IE, Opera, snad i Firefox}
        BrowseURL('file:///' + outFolder + mapList[selectedMap].File);
      end;
  end;
end;

{-----------------------------------------------------------------------------------------------------------------------
  PluginStart - hlavn procedura}
procedure AniMapaStart;
begin
  ReadSettings;                                     // nati parametry z INI pluginu
  if not staySilent then
  {dialogov reim}
  begin
    ReadMapList;                                    // nati seznam dostupnch map
    if AniMapaForm.ShowModal = 1 then               // zobraz formul a pokud bylo OK, generuj mapu
      begin
        SaveSettings;                               // ulo parametry do INI
        SetGlobalParams;                            // nastav globln parametry animace
        GenerateMap;                                // generuj mapu
      end;
    AniMapaForm.Close;
  end
  else
  {tich reim - zachovno pro zptnou kompatibilitu, od verze 1.0.1 je msto toho skript AniMapaSilent}
  begin
    ReadMapList;                                    // nati seznam dostupnch map
    SetGlobalParams;                                // nastav globln parametry animace
    GenerateMap;                                    // generuj mapu
  end;
end;
